=== tests/auto/grpc/qgrpccalloptions/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qgrpccalloptions LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qgrpccalloptions
    SOURCES
        tst_qgrpccalloptions.cpp
    INCLUDE_DIRECTORIES
        "${CMAKE_CURRENT_LIST_DIR}/../shared"
    LIBRARIES
        Qt::Core
        Qt::Test
        Qt::Grpc
)
